#include<stdio.h>
#include<iostream>
#include<cmath>
using namespace std;

double mA[30]={0, 1.00794, 4.002602, 6.941,  9.012, 10.811, 12.0107, 14.007, 15.9994,  18.9994, 20.1797, 22.98977, 24.3050, 26.981538, 28.0855, 
	       30.973761, 32.065, 35.453, 39.948, 39.0983,  40.078, 44.955910, 47.867, 50.9415, 51.9961, 54.938049, 55.845, 58.933, 58.6934};//masse in amu

/////////////////////////////////////////////
double powerlaw(double* x, double* par)
{
  double val = par[0] * pow(x[0], par[1]);
  return val;
}


double Factor(int ZF, int ZI, int NZI, int NZF)
{
  double FACTOR = 1.0;
  if ( (ZF == 27) && ( (ZI-ZF) == 1) ) FACTOR=0.75;
  if ( (ZF == 26) && ( (ZI-ZF) == 2) ) FACTOR=1.18;
  if ( (ZF == 25) && ( (ZI-ZF) == 1) ){ 
    if (NZI==4) FACTOR=1.02;
    if (NZI==2) FACTOR=0.64;
  }
  if ( (ZF == 24) && ( (ZI-ZF) == 1) ) FACTOR=1.13;
  if ( (ZF == 24) && ( (ZI-ZF) == 2) ){
    if (NZI==4) FACTOR=1.01;
    if (NZI==2) FACTOR=0.85;
  }
  if ( (ZF == 24) && ( (ZI-ZF) == 4) ) FACTOR=1.09;
  if ( (ZF == 23) && ( (ZI-ZF) == 1) ) FACTOR=0.95;
  //if ( (ZF == 23) && ( (ZI-ZF) == 2) ) FACTOR=1.05;
  if ( (ZF == 23) && ( (ZI-ZF) == 3) ) FACTOR=1.02;
  if ( (ZF == 22) && ( (ZI-ZF) == 2) ) FACTOR=0.96;
  if ( (ZF == 22) && ( (ZI-ZF) == 3) ) FACTOR=0.91;
  if ( (ZF == 22) && ( (ZI-ZF) == 4) ) FACTOR=1.02;
  if ( (ZF == 21) && ( (ZI-ZF) == 1) ) FACTOR=0.90;
  if ( (ZF == 21) && ( (ZI-ZF) == 2) ) FACTOR=0.68;
  if ( (ZF == 21) && ( (ZI-ZF) == 3) ) FACTOR=0.95;
  if ( (ZF == 21) && ( (ZI-ZF) == 4) ) FACTOR=0.90;
  if ( (ZF == 21) && ( (ZI-ZF) == 5) ) FACTOR=0.98;
  if ( (ZF == 21) && ( (ZI-ZF) == 7) ) FACTOR=0.85;
  if ( (ZF == 20) && ( (ZI-ZF) == 4) ) FACTOR=0.94;
  if ( (ZF == 20) && ( (ZI-ZF) == 5) ) FACTOR=0.89;
  //if ( (ZF == 20) && ( (ZI-ZF) == 6) ) FACTOR=0.96;
  if ( (ZF == 20) && ( (ZI-ZF) == 8) ) FACTOR=0.88;
  if ( (ZF == 19) && ( (ZI-ZF) == 1) ){
    if (NZI==4) FACTOR=0.71;
    if (NZI==2) FACTOR=0.65;
    if (NZI==0) FACTOR=0.34;
  }
  if ( (ZF == 19) && ( (ZI-ZF) == 6) ) FACTOR=1.12;
  if ( (ZF == 19) && ( (ZI-ZF) == 7) ){ 
    if (NZI==2) FACTOR=1.25;
  }
  if ( (ZF == 19) && ( (ZI-ZF) == 9) ) FACTOR=1.16;
  if ( (ZF == 18) && ( (ZI-ZF) == 2) ){
    if (NZI==2) FACTOR=0.88;
    if (NZI==0) FACTOR=1.40;
  }
  if ( (ZF == 18) && ( (ZI-ZF) == 6) ) FACTOR=1.10;
  if ( (ZF == 18) && ( (ZI-ZF) == 8) ){ 
    if (NZI==4) FACTOR=1.03;
    if (NZI==2) FACTOR=1.30;
  }
  if ( (ZF == 17) && ( (ZI-ZF) == 1) ){ 
    if (NZI==4) FACTOR=1.12;
    if (NZI==2) FACTOR=0.80;
    if (NZI==0) FACTOR=0.68;
  }
  if ( (ZF == 17) && ( (ZI-ZF) == 3) ) FACTOR=0.98;
  if ( (ZF == 17) && ( (ZI-ZF) == 9) ) FACTOR=1.05;
  if ( (ZF == 16) && ( (ZI-ZF) == 1) ) FACTOR=0.74;
  if ( (ZF == 16) && ( (ZI-ZF) == 2) ){ 
    if (NZI==4) FACTOR=1.14;
    if (NZI==2) FACTOR=1.02;
    if (NZI==0) FACTOR=1.18;
  }
  if ( (ZF == 16) && ( (ZI-ZF) == 4) ){
    if (NZI==4) FACTOR=1.13;
    if (NZI==3) FACTOR=1.12;
    if (NZI==2) FACTOR=1.07;
    if (NZI==0) FACTOR=1.38;
  }
  if ( (ZF == 16) && ( (ZI-ZF) == 7) ) FACTOR=1.25;
  if ( (ZF == 16) && ( (ZI-ZF) == 8) ) FACTOR=1.07;
  if ( (ZF == 16) && ( (ZI-ZF) == 9) ) FACTOR=0.87;
  if ( (ZF == 16) && ( (ZI-ZF) ==10) ) FACTOR=1.05;
  if ( (ZF == 15) && ( (ZI-ZF) == 1) ){ 
    if (NZI==1) FACTOR=0.86;
    if (NZI==0) FACTOR=0.70;
  } 
  if ( (ZF == 15) && ( (ZI-ZF) == 3) ){ 
    if (NZI==4) FACTOR=1.10;
    if (NZI==2) FACTOR=0.96;
    if (NZI==0) FACTOR=0.90;
  }
  if ( (ZF == 15) && ( (ZI-ZF) == 5) ) FACTOR=1.12;
  if ( (ZF == 15) && ( (ZI-ZF) == 9) ) FACTOR=0.60;
  if ( (ZF == 15) && ( (ZI-ZF) ==10) ) FACTOR=0.70;
  if ( (ZF == 15) && ( (ZI-ZF) ==11) ) FACTOR=0.67;
  if ( (ZF == 15) && ( (ZI-ZF) ==13) ) FACTOR=0.70;
  if ( (ZF == 14) && ( (ZI-ZF) == 1) ) FACTOR=0.75;
  if ( (ZF == 14) && ( (ZI-ZF) == 2) ) FACTOR=1.06;
  if ( (ZF == 14) && ( (ZI-ZF) == 4) ){ 
    if (NZI==4) FACTOR=1.07;
    if (NZI==2) FACTOR=1.08;
    if (NZI==0) FACTOR=1.23;
  }
  if ( (ZF == 14) && ( (ZI-ZF) == 6) ){
    if (NZI==4) FACTOR=0.92;
    if (NZI==2) FACTOR=1.04;
    if (NZI==0) FACTOR=1.38;
  }
  if ( (ZF == 14) && ( (ZI-ZF) ==10) ) FACTOR=0.80;
  if ( (ZF == 14) && ( (ZI-ZF) ==11) ) FACTOR=0.65;
  if ( (ZF == 14) && ( (ZI-ZF) ==12) ) FACTOR=0.67;
  if ( (ZF == 14) && ( (ZI-ZF) ==14) ) FACTOR=0.63;
  if ( (ZF == 13) && ( (ZI-ZF) == 1) ){
    if (NZI==1) FACTOR=0.83;
    if (NZI==0) FACTOR=0.81;
  }
  if ( (ZF == 13) && ( (ZI-ZF) == 3) ){
    if (NZI==1) FACTOR=0.90;
  }
  if ( (ZF == 13) && ( (ZI-ZF) == 5) ){
    if (NZI==4) FACTOR=1.25;
    if (NZI==0) FACTOR=1.15;
  }
  if ( (ZF == 13) && ( (ZI-ZF) == 7) ) FACTOR=1.04;
  if ( (ZF == 13) && ( (ZI-ZF) ==13) ) FACTOR=0.60;
  if ( (ZF == 12) && ( (ZI-ZF) == 1) ) FACTOR=1.07;
  if ( (ZF == 12) && ( (ZI-ZF) == 2) ) FACTOR=0.89;
  if ( (ZF == 12) && ( (ZI-ZF) == 4) ){
    if (NZI==1) FACTOR=0.96;
    if (NZI==0) FACTOR=1.20;
  }
  if ( (ZF == 12) && ( (ZI-ZF) == 6) ){
    if (NZI==2) FACTOR=0.91;
    if (NZI==0) FACTOR=1.07;
  }
  if ( (ZF == 12) && ( (ZI-ZF) == 8) ){
    if (NZI==4) FACTOR=1.25;
    if (NZI==2) FACTOR=0.90;
  }
  if ( (ZF == 11) && ( (ZI-ZF) == 1) ){
    if (NZI==2) FACTOR=1.11;
    if (NZI==1) FACTOR=1.10;
    if (NZI==0) FACTOR=1.16;
  }
  if ( (ZF == 11) && ( (ZI-ZF) == 2) ) FACTOR=1.28;
  if ( (ZF == 11) && ( (ZI-ZF) == 3) ){    
    if (NZI==1) FACTOR=1.01;
    if (NZI==0) FACTOR=0.80;
  }
  if ( (ZF == 10) && ( (ZI-ZF) == 1) ) FACTOR=1.35;
  if ( (ZF == 10) && ( (ZI-ZF) == 2) ){ 
    if (NZI==2) FACTOR=1.11;
    if (NZI==1) FACTOR=0.89;
    if (NZI==0) FACTOR=0.90;
  }
  if ( (ZF == 10) && ( (ZI-ZF) == 3) ) FACTOR=0.94;
  if ( (ZF == 10) && ( (ZI-ZF) == 4) ){
    if (NZI==1) FACTOR=1.04;
    if (NZI==0) FACTOR=0.97;
  }
  if ( (ZF == 10) && ( (ZI-ZF) == 6) ){
    if (NZI==1) FACTOR=0.85;
    if (NZI==0) FACTOR=1.20;
  }
  if ( (ZF == 10) && ( (ZI-ZF) == 7) ) FACTOR=1.45;
  if ( (ZF == 10) && ( (ZI-ZF) == 8) ) FACTOR=0.83;
  if ( (ZF == 10) && ( (ZI-ZF) ==10) ) FACTOR=0.86;
  if ( (ZF == 9) && ( (ZI-ZF) == 1) ){
    if (NZI==2) FACTOR=1.14;
    if (NZI==1) FACTOR=1.08;
    if (NZI==0) FACTOR=0.97;
  }
  if ( (ZF == 9) && ( (ZI-ZF) == 2) ) FACTOR=1.35;
  if ( (ZF == 9) && ( (ZI-ZF) == 3) ){
    if (NZI==2) FACTOR=1.40;
    if (NZI==1) FACTOR=1.12;
    if (NZI==0) FACTOR=0.90;
  }
  if ( (ZF == 9) && ( (ZI-ZF) == 4) ) FACTOR=0.83;
  if ( (ZF == 9) && ( (ZI-ZF) == 5) ) FACTOR=0.93;
  if ( (ZF == 9) && ( (ZI-ZF) == 7) ) FACTOR=1.26;
  if ( (ZF == 8) && ( (ZI-ZF) == 1) ) FACTOR=0.82;
  if ( (ZF == 8) && ( (ZI-ZF) == 2) ){ 
    if (NZI==2) FACTOR=0.72;
    if (NZI==1) FACTOR=0.83;
    if (NZI==0) FACTOR=0.87;
  }
  if ( (ZF == 8) && ( (ZI-ZF) == 4) ){ 
    if (NZI==2) FACTOR=0.76;
    if (NZI==1) FACTOR=0.89;
    if (NZI==0) FACTOR=1.02;
  }
  if ( (ZF == 8) && ( (ZI-ZF) == 5) ) FACTOR=0.93;
  if ( (ZF == 8) && ( (ZI-ZF) == 6) ){ 
    if (NZI==1) FACTOR=0.83;
    if (NZI==0) FACTOR=0.89;
  }
  if ( (ZF == 8) && ( (ZI-ZF) == 8) ) FACTOR=0.95;
  if ( (ZF == 8) && ( (ZI-ZF) ==10) ) FACTOR=0.63;
  if ( (ZF == 7) && ( (ZI-ZF) == 1) ) FACTOR=0.90;
  if ( (ZF == 7) && ( (ZI-ZF) == 2) ) FACTOR=0.93;
  if ( (ZF == 7) && ( (ZI-ZF) == 3) ) FACTOR=1.08;
  if ( (ZF == 7) && ( (ZI-ZF) == 7) ) FACTOR=0.87;
  if ( (ZF == 6) && ( (ZI-ZF) == 1) ){ 
    if (NZI==1) FACTOR = 0.99;
    if (NZI==0) FACTOR = 1.21;
  }
  if ( (ZF == 6) && ( (ZI-ZF) == 2) ) FACTOR=0.78;
  if ( (ZF == 6) && ( (ZI-ZF) == 4) ){
    if (NZI==2) FACTOR=0.90;
  }
  if ( (ZF == 6) && ( (ZI-ZF) ==10) ) FACTOR=1.15;
  if ( (ZF == 5) && ( (ZI-ZF) == 1) ) FACTOR=0.90;
  if ( (ZF == 5) && ( (ZI-ZF) == 2) ){ 
    if (NZI==1) FACTOR=1.75;
    if (NZI==0) FACTOR=1.34;
  }
  if ( (ZF == 5) && ( (ZI-ZF) == 3) ) FACTOR=1.01;
  if ( (ZF == 5) && ( (ZI-ZF) == 5) ) FACTOR=0.94;
  if ( (ZF == 5) && ( (ZI-ZF) == 6) ) FACTOR=1.20;
  if ( (ZF == 5) && ( (ZI-ZF) == 7) ) FACTOR=1.28;
  if ( (ZF == 5) && ( (ZI-ZF) == 9) ) FACTOR=1.35;
  if ((ZF==4) && ((ZI-ZF)==1) && (NZI==1)){ 
    if (NZF==1) FACTOR=1.89;
    if (NZF==-1) FACTOR=0.05;
  }
  if ( (ZF==4) && ((ZI-ZF)==3) &&(NZI==1) ){
    if (NZF==2) FACTOR=1.90;
    if (NZF==1) FACTOR=1.60;
    if (NZF==-1) FACTOR=0.25;
  }
  if ( (ZF == 4) && ( (ZI-ZF) == 4) ) FACTOR=0.94;
  if ((ZF==3) && ((ZI-ZF)==1) &&   ((NZI==1) || (NZI==2))){
    if (NZF==1) FACTOR=0.80;
    if (NZF==0) FACTOR=0.36;
  }
  if ((ZF==3) && ((ZI-ZF)==2) && (NZI==1)){
    if (NZF==1) FACTOR=1.35;
    if (NZF==0) FACTOR=0.63;
  }
  return FACTOR;
}


int TotalCCxsec() //Total charge changing cross section at 1.5 GeV/n (Webber et al.,  Phys Rev C 41 (1990), 520)
{
  gStyle->SetOptFit(1111);
  gStyle->SetOptStat(0);

  //total charge-changing cross-sections, table IV Webber Phys Rev C 41 (1990), 520 
  int Znucleus[12] =    {  6,   7,   8,  10,  12,  13,  14,  16,  18,  20,  26,  28};
  double xsecH_exp[12] =   {228, 252, 275, 328, 382, 406, 418, 469, 548, 548, 714, 783};
  double DxsecH_exp[12] =  {  4,   4,   5,   6,   7,   7,   7,   8,   9,   9,  11,  15};
  double xsecHe_exp[] =  {431, 482, 512,   0,   0, 796,   0,   0,   0,   0,1196,   0};
  double DxsecHe_exp[] = {  7,   8,   9,   0,   0,  12,   0,   0,   0,   0,  21,   0};

  TGraphErrors* gH = new TGraphErrors(12);
  gH->SetMarkerColor(1);
  gH->SetLineColor(1);
  gH->SetMarkerStyle(20);
  gH->SetMarkerSize(0.8);
  for(int i=0; i<12; i++){
    double m = mA[Znucleus[i]];
    gH->SetPoint(i, m,  xsecH_exp[i]);
    gH->SetPointError(i, 0, DxsecH_exp[i]);
  }

  TGraphErrors* gHe = new TGraphErrors(5);
  gHe->SetMarkerColor(2);
  gHe->SetLineColor(2);
  gHe->SetMarkerStyle(21);
  gHe->SetMarkerSize(0.8);
  int idx = 0;
  for(int i=0; i<12; i++){
    double m = mA[Znucleus[i]];
    if(xsecHe_exp[i]==0) continue;
    gHe->SetPoint(idx, m,  xsecHe_exp[i]);
    gHe->SetPointError(idx++, 0, DxsecHe_exp[i]);
  }

  TCanvas* c1 = new TCanvas("c1","",700,700);
  c1->Divide(1,2);
  TH2F* h2 = new TH2F("h2"," ;A; #sigma (mb)",400,5,150,400, 99, 1e4);
  c1->cd(1)->SetLogx();
  c1->cd(1)->SetLogy();
  h2->Draw();
  gH->Draw("P");
  gHe->Draw("P");
  TF1* fH = new TF1("fH",powerlaw,10,65,2);
  fH->SetParameters( 50, 0.6);
  fH->SetLineColor(1);
  gH->Fit("fH","R");
  TF1* fHe = new TF1("fHe",powerlaw,10,65,2);
  fHe->SetParameters( 50, 0.6);
  fHe->SetLineColor(2);
  gHe->Fit("fHe","R");

  //total charge changing cross section (in mbarn) at 1.5 GeV/n mbarn
  //paramterisation from fit  Ap + H (table IV,VI e fig.7, Webber, Phys Rev C41 (1990), 520)
  TF1* fwH = new TF1("fwH",powerlaw,1,85,2);
  fwH->SetLineColor(4);
  fwH->SetLineStyle(7);
  fwH->SetParameters( 34.9, 0.75);
  fwH->Draw("sames");
  //total charge changing cross section (in mbarn) at 1.5 GeV/n mbarn
  //paramterisation from fit  Ap + He (table IV, VI e fig.7, Webber, Phys Rev C41 (1990), 520) 
  TF1* fwHe = new TF1("fwHe",powerlaw,1,85,2);
  fwHe->SetLineColor(4);
  fwHe->SetLineStyle(7);
  fwHe->SetParameters( 88.7, 0.64);
  fwHe->Draw("sames");

  c1->cd(2)->SetLogx();
  TGraphErrors* gHres = new TGraphErrors(12);
  gHres->SetMarkerColor(1);
  gHres->SetLineColor(1);
  gHres->SetMarkerStyle(20);
  gHres->SetMarkerSize(0.6);
  for(int i=0; i<12; i++){
    double x,y;
    gH->GetPoint(i,x,y);
    double ey = gH->GetErrorY(i);
    double r = 1 - fH->Eval(x)/y;
    double er = fH->Eval(x)/(y*y)*ey;
    gHres->SetPoint(i, x,  r);
    gHres->SetPointError(i, 0, er);
  }
  TGraphErrors* gHeres = new TGraphErrors(5);
  gHeres->SetMarkerColor(2);
  gHeres->SetLineColor(2);
  gHeres->SetMarkerStyle(20);
  gHeres->SetMarkerSize(0.6);
  for(int i=0; i<5; i++){
    double x,y;
    gHe->GetPoint(i,x,y);
    double ey = gHe->GetErrorY(i);
    double r = 1 - fHe->Eval(x)/y;
    double er = fHe->Eval(x)/(y*y)*ey;
    gHeres->SetPoint(i, x,  r);
    gHeres->SetPointError(i, 0, er);
  }

  TH2F* h3 = new TH2F("h3"," ;A; (#sigma_{exp} - #sigma_{fit})/#sigma_{exp}",400,5,150,400, -0.2,0.2);
  h3->Draw();
  gHres->Draw("P");
  gHeres->Draw("P");


  double amu = 1.66053886e-27;//kg
  double c   = 3e8; //m/s
  double J2ev = 1.0/1.6e-19;//conversion factor J->Gev

  printf("Z       xsec_H           xsec_He       Lambda_ISM (g/cm2)\n");
  //compute total charge changin cross section
  for(int i=0; i<30; i++){
    if(mA[i]==0) continue;
    double Ap = mA[i];//projectile
    double xsecH = fH->Eval(Ap);
    double xsecHe = fHe->Eval(Ap);
    double wxsecH = fwH->Eval(Ap);
    double wxsecHe = fwHe->Eval(Ap);
    //interaction length in ISM: 90% H 10% He
    double MFP = (0.9* mA[1]+ 0.1* mA[2])/ ((xsecH*0.9+xsecHe*0.1)*1e-27) *amu*1e3;
    printf("%2d   %4.0f  (%4.0f)    %4.0f   (%4.0f)  %7.3f\n",i, xsecH, wxsecH, xsecHe, wxsecHe, MFP);
    
  }

  return 1;
}


int PartialCCxsec() //Partial charge changing cross section at 600 MeV/n (Webber et al.,  Phys Rev C 41 (1990), 566)
{
  //UPDATED FORMULA FOR CALCULATING PARTIAL CROSS SECTIONS FOR NUCLEAR REACTIONS 
//Table I - Partial charge changing cross section of nuclei at 600 MeV/n on H target (Webber et al. ApJ S144 (2003) 153)
  static const int N=28;
  int STARTZ = 3;
  //                  0 1 2   3    4    5     6      7      8     9     10    11     12     13     14     15     16     17     18    19     20     21     22     23     24     25    26   27  
  double sigma_Zf[N]={0,0,0,41.0,17.3,56.0,123.0, 105.0,125.0, 69.5, 100.0, 93.0, 129.0, 112.0, 160.0, 136.0, 150.0, 130.0, 136.5, 135.5, 156.0, 146.0, 151.5, 135.7, 162.8, 150.0, 182.0,181.0};
  double Delta_Zf[N]={0,0,0, 6.0, 9.2, 4.2,  5.0,   4.4,  5.0,  3.7,   5.0,  5.0,   5.6,   5.5,   5.2,   4.5,  4.75,   4.5,   5.0,   4.7,   5.8,   5.6,   7.2,   7.0,   7.3,   7.0,   7.5,  5.0};
  double N0Zf[N] =   {0,0,0, 0.4, 0.0, 0.40, 0.0,   0.4,  0.0,  0.7,   1.0,  0.7,  1.15,   1.0,   1.5,  1.65,  1.75,   1.8,   2.4,   2.6,   2.8,   3.1,   3.4,   3.6,   3.8,   4.0,   4.0,  4.0};
  //DeltaZ =           0      1      2      3      4      5      6      7      8      9    10     11   12     13    14    15   16    17    18
  double B_DZ[19] = {-0.08, -0.07, -0.10, -0.07, -0.10, -0.07, -0.06, -0.04, -0.01, -0.07, 0.02, 0.02, 0.04, 0.07, 0.10, 0.13, 0.16, 0.19, 0.22};

  //Table I - Partial charge changing cross section of nuclei at 600 MeV/n on H target (Webber et al.,  Phys Rev C 41 (1990), 566)
  /* static const int N=26;
  int STARTZ = 4;
  //                    0  1 2 3    4    5     6     7     8     9     10    11     12     13     14     15     16     17     18    19     20     21     22     23     24     25
  double sigma_Zf[N] = {0, 0,0,0, 19.6, 61.2, 94.0, 86.6, 99.2, 59.2, 99.2, 102.5, 134.5, 112.0, 145.0, 112.5, 142.5, 140.1, 144.5, 74.8, 160.2, 126.6, 158.0, 135.7, 154.6, 161.4};
  double Delta_Zf[N] = {0, 0,0,0,  6.1,  3.9,  6.2,  4.8,  6.3,  3.1,  5.4,   4.1,   6.2,   4.3,   6.2,   4.9,   5.6,   4.5,   4.9,  6.9,   5.9,   5.9,   6.2,   6.2,  8.2,    5.7};
  */

  double XS[N][N] = {{0},{0}};
  double XSf[N][N] = {{0},{0}};
  
  printf("Zf");
  for(int zf=STARTZ; zf<N; zf++)
    printf("|%4d ", zf);
  printf("\n");
  printf("Zi ------------------------------------------------------------------------------------------------------------------------------------------------------\n");
  for(int zi=STARTZ; zi<N+1; zi++){//loop over z of projectile
    printf("%2d",zi);
    for(int zf=STARTZ; zf<N; zf++){//loop over z of the product of fragmentation
      if(zf>=STARTZ && zf<zi){
        int Af = (int) (mA[zf]+0.5);
        int Ai = (int) (mA[zi]+0.5);
        double N_Zf = Af - 2*zf;//neutron excess in final nucleus
	double N_Zi = Ai - 2*zi;//neutron excess in projectile nucleus

	//partial XS    (Zi, Ai) + H --> (Zf, Af) 
	//double XS = sigma_Zf[zf] * TMath::Exp(-(zi-zf)/Delta_Zf[zf]) * TMath::Exp( -TMath::Abs(N_Zi - N_Zf)/20.0);//ApJ
      	double xs = sigma_Zf[zf] * TMath::Exp(-(zi-zf)/Delta_Zf[zf]) * TMath::Exp( -TMath::Abs(N_Zi - N0Zf[zf])/20.0);//tesi hoopner
      	printf("|%5.1f",xs);
	XS[zi][zf] = xs;
      }
      else
	printf("|     ");
    }
    printf("\n");
  }
  
    //asymptotic correction at high energy
    printf("\n Energy correction \n");
    printf("Zf");
    for(int zf=STARTZ; zf<N; zf++)
      printf("|%4d ", zf);
    printf("\n");
    printf("Zi ------------------------------------------------------------------------------------------------------------------------------------------------------\n");
    for(int zi=STARTZ; zi<N+1; zi++){//loop over z of projectile
      printf("%2d",zi);
      for(int zf=STARTZ; zf<N; zf++){//loop over z of the product of fragmentation
	if(zf>=STARTZ && zf<zi){
	  int Af = (int) (mA[zf]+0.5);
	  int Ai = (int) (mA[zi]+0.5);
	  double N_Zf = Af - 2*zf;//neutron excess in final nucleus
	  double N_Zi = Ai - 2*zi;//neutron excess in projectile nucleus
	  double factor = Factor(zf, zi, N_Zi, N_Zf);
	  double xsf = XS[zi][zf]*factor;
	  XSf[zi][zf] = xsf;
	  //double err = (xsf - XS[zi][zf])/XS[zi][zf];
	  printf("|%5.1f",xsf);
	  //printf("|%5.2f",err);
	  //cout<<zi<<" "<<zf<<"  "<<factor<<"  "<<xsf<<endl;
	  
	  /*double bZi = 1.0;
	  if(zi<26) bZi = pow(zi*1.0/26.0, 0.4);
	  int DZ = zi-zf;
	  double fENE = 1 + B_DZ[DZ]* bZi *2.2*1.33;//correction from Hopper's thesis to compute cross section at high-energy (>4 GeV/n)
	  double xse = XS[zi][zf]*fENE;
	  cout<<zi<<"  "<<zf<<"  "<<DZ<<"  "<<fENE<<"   "<<XS[zi][zf]<<"  "<<xse<<endl;
	  //printf("|%5.1f",xse);
	  */

	}
	else
	  printf("|     ");
      }
      printf("\n");
    }
    
    //
    //energy correction 
   
    //bZi = Zi/26.;
    // double E = 5000;
    // fENE = 1 + B_DZ[DZ]* bZi * (E-2000)/2000;;
  
    //CS *= factor;
    // double CSxFACTOR = CS*factor;
    //double CSxFACTORxfENE = CS*fENE;
    //printf("Zi=%2.0f --> Zf=%2.0f  CS=%9.4f  (%.3f) FACTOR=%5.3f  fENE=%.3f    CSxFACTOR=%9.4f  (%.3f)    CSxFACTORxfENE=%9.4f (%.3f)\n",Zi, Zf, CS, CS/ccXS, factor, fENE,
    //CSxFACTOR, CSxFACTOR/ccXS, CSxFACTORxfENE, CSxFACTORxfENE/ccXS);*/
    // }
  
  return 1;
}


